#ifndef _CONTRAINTES_H
#define _CONTRAINTES_H

#include <map>
#include <list>
#include <string>
#include <algorithm>
#include <iostream>
#include <strstream>
#include "fileconfig.h"
/*
classe grant les contraintes impos lors de la cration de la base de donnes du moteur de recherche

*/
class Contraintes{

  public:

  //constructeur par defaut
  Contraintes():profondeurMaxOfSearch(4),timeout(3),domaine(""),chemin(""){

  };

  Contraintes(char * fichier){
     FileConfig fcfg=FileConfig(fichier);
     timeout =fcfg.getTime();
     if(fcfg.getDomaine().length()>=7){
    	domaine=getDomaine(fcfg.getDomaine());
    	chemin=getChemin(fcfg.getDomaine());
    }else{
    	domaine=getDomaine("XXXXXXX"+fcfg.getDomaine());
    	chemin=getChemin("XXXXXXX"+fcfg.getDomaine());
    }
    profondeurMaxOfSearch=fcfg.getDeep();
    theme=fcfg.getTheme();
    extension=fcfg.getType();

  };
  //constructeur 
  Contraintes(map<string,unsigned> themap, list<string> extype,int prof,int time,string domaineAuthorized):profondeurMaxOfSearch(prof),timeout(time){
    theme=themap;
    extension=extype;
    domaine=getDomaine("XXXXXXX"+domaineAuthorized);
    chemin=getChemin("XXXXXXX"+domaineAuthorized);
  };
  
  Contraintes(map<string,unsigned> themap, list<string> extype):profondeurMaxOfSearch(4),timeout(3),domaine(""),chemin(""){
    theme=themap;
    extension=extype;
  };
  
  //renvoie vrai si l'url est dans la restriction au domaine
    bool isInDomaine(string url);
    
    //renvoie le time out Max d'une requte
    int getTimeOut();
    
    //renvoie si le mot est du theme et significatif
    int wordValue(string mot);
    
    //ajout d'une liste au thme
    void addMapOfTheme(map<string,unsigned> & motsTheme);
    
    //ajoute un mot au thme
    void addWordOfTheme(string mot, unsigned occurenceMin);
  
    //renvoie vrai si le type est gr ou accept
    bool typeAcceptable(string & type);

    //renvoie vrai si l'entete et correcte de la page
     bool pageAcceptable(const string & page);
    
    //ajout d'une liste au extension
    void addListOfExtension(list<string> & listExtension);
  
    //ajoute un type au extension autoris
    void addTypeOfExtension(string &  typeExt);
    
    //renvoie la profondeur max autoris pour les visites par le spider
    int getProfondeur();
    
    //renvoie la liste des types autoris
    list<string> getType();
    
    //renvoie la map des mots du thme
    map<string,unsigned> getTheme();


    private : 
      //petit traitement sur le domaine afin de faire une legere optimisation
      string getDomaine(string url);
    string getChemin(string url);
    void affichelist();
    void affichemap();	

    string & lowerCase( string & word ) {
			for( unsigned int i = 0; i < word.length(); i++ ) {
				if( word[i] >= 'A' && word[i] <='Z' )
					word[i] = word[i] - 'A' + 'a';
			}
		return word;	
	}
	
       
    int  profondeurMaxOfSearch;
    int timeout;//delai Max pour une requete  un site
    string domaine;//restriction du domaine
    string chemin;//restriction du chemin
	public:
    typedef  map<string,unsigned> ConstraintWord;
    ConstraintWord theme;//liste des mots du thme
   private:
    typedef list<string> ListeTheme;
    ListeTheme extension;//extension autoris
    
};
#endif
