/***************************************************************************
                          loadfile.cpp  -  description
                             -------------------
    begin                : Mon May 27 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include <errno.h>
#include <iostream>
#include <netdb.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>

#include "loadfile.h"


ConnectBase LoadFile::dataBase;


void LoadFile::run() {
	while( !quit ) {
		while( mutexNbFile.getVal() > 50 ) {
			sleep( 5 );
		}
	
		File & file = newCurrentFile();
		file.url = popUrl();
		if( quit )
			break;
			
		if( contraint.isInDomaine( file.url.url ) && !dataBase.dejaVu( file.url.url ) ) {
			clog << "PILE URL: " << mutexNbUrl.getVal() << " -> " << mutexNbFile.getVal() << ' ';
			string url;
			if( file.url.url.substr( 0, 7 ) == "http://" )
				url = file.url.url.substr( 7 );
			else
				url = file.url.url;
			if( getHttpFile( url.c_str(), file.data ) ) {
//				clog << "DOWNLOAD "  << file.url << endl;
				string req = "INSERT IGNORE INTO Url (url, lastVisit) VALUES (" + ConnectBase::formatString( file.url.url ) + ", NOW() )";
				try { dataBase.executeQuery( req ); } catch (...) { cout << "EXCEPTION URL LOADFILE" << endl; }
			}
			else	{
				clog << "ERROR DOWNLOAD " << file.url.url << " : " << strError() << endl;
				file.data = "";
			}
		
		}
			
		mutexNbFile.V();
	}
}


LoadFile::LoadFile(  Contraintes & c ) : quit( false ), mutexNbUrl( 0 ), mutexNbFile( 0 ), contraint( c ) {
	start();
}


LoadFile::~LoadFile() {
	stop();
}


// deprecated !!!!!!!!!!!
bool LoadFile::isLoading( const string & url ) {
/*	mutexUrl.P();
	for( 	FifoUrl::const_iterator i = urlToLoad.begin(); i != urlToLoad.end(); ++i)
		if( *i == url ) {
			mutexUrl.V();
			return true;
		}
	mutexUrl.V();

	mutexFile.P();
	for( 	::const_iterator i = fifoLoadedFile.begin(); i != fifoLoadedFile.end(); ++i)
		if( i->url == url ) {
			mutexFile.V();
   		return true;
		}
	mutexFile.V();
*/		
	return false;
}


void LoadFile::loadFile( const UrlInfo & url ) {
	pushUrl( url );	
}


LoadFile::File & LoadFile::newCurrentFile() {
	mutexFile.P();
		File temp;
		fifoLoadedFile.push_back(temp);
		File & file = fifoLoadedFile.back();
	mutexFile.V();
	return file;
}


void LoadFile::waitFile() {
	mutexNbFile.P();
}


LoadFile::File & LoadFile::getFile() {
	mutexFile.P();
	File & file = fifoLoadedFile.front();
	mutexFile.V();
	return file;
}


void LoadFile::popFile() {
	mutexFile.P();
	fifoLoadedFile.pop_front();
	mutexFile.V();
}


bool LoadFile::getHostByName( const char * url, string & nameServer, string & path, sockaddr_in & addr ) {
	for( ; *url != '/' && *url != '\0'; ++url )
		nameServer += *url;
		
	if( '\0' == *url )
		path += '/';
	else
		for( ; *url != '\0'; ++url )
			path += *url;	
			
	struct hostent * host =	gethostbyname2( nameServer.c_str(), AF_INET );
	if( 0 == host )
		return false;
		
	addr.sin_family = AF_INET;
	addr.sin_port = htons( 80 );
	addr.sin_addr.s_addr = *( ( unsigned long * ) host->h_addr );
	
	return true;
}


static bool canRead( int sd ) {
   fd_set rfds;
   struct timeval tv;
   FD_ZERO( &rfds );
   FD_SET( sd, &rfds );
   tv.tv_sec = 2;
   tv.tv_usec = 0;
   return 0 == select( 1, &rfds, 0, 0, &tv );
}

	
bool LoadFile::getHttpFile( const char * url, string & page )  {
	sockaddr_in addrServer;
	string nameServer;
	string path;
	
	if( !getHostByName( url, nameServer, path, addrServer ) )
		return false;
		
	int sd = socket( AF_INET, SOCK_STREAM, 0 );
	
	if( -1 == sd )
		return false;

	int MAXMSG = 128;
	socklen_t len = sizeof( MAXMSG );
	getsockopt( sd, SOL_SOCKET, SO_RCVBUF, &MAXMSG, &len );
			
	if( 0 != connect( sd, (sockaddr *) &addrServer, sizeof( sockaddr_in ) ) )  {
		close( sd );
		return false;
	}
	
	string msgToSend  =  "GET " + path  + " HTTP/1.1\r\nHost: " + nameServer + "\r\nConnection: close\r\n\r\n";
	if (-1 == write( sd, msgToSend.c_str(), msgToSend.size() ) ) {
		close( sd );
		return false;
	}
	shutdown( sd, 1 );
		
	char msg[ MAXMSG+1 ];		
	if( !canRead( sd ) ) {
		close( sd );
		cout << "ERROR TIMEOUT" << endl;
		return false;
	}
	int nbBytes = read( sd, msg, MAXMSG );
	msg[ nbBytes ] = '\0';
	page.append( msg, nbBytes );
	if( !contraint.pageAcceptable( page ) ) {
		close( sd );
		return false;
	}
	while( nbBytes > 0 ) {
		if( !canRead( sd ) ) {
			close( sd );
			cout << "ERROR TIMEOUT" << endl;
			return false;
		}
		nbBytes = read( sd, msg, MAXMSG );
		msg[ nbBytes ] = '\0';
		page.append( msg, nbBytes );
	}
	close( sd );	
	return true;
	
}


const char * LoadFile::strError() {
	return strerror( errno );
}


void LoadFile::pushUrl( const UrlInfo & url ) {
	mutexUrl.P();
		urlToLoad.push( url );
	mutexUrl.V();
	mutexNbUrl.V();
}


UrlInfo LoadFile::popUrl() {
	mutexNbUrl.P();
	mutexUrl.P();
		UrlInfo url = urlToLoad.top();
		urlToLoad.pop();
	mutexUrl.V();
	return url;
}


void LoadFile::stop() {
	quit = true;
	mutexNbFile.V();
	join();
}
