/***************************************************************************
                          loadfile.h  -  description
                             -------------------
    begin                : Mon May 27 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#ifndef _LOADFILE_H_
#define _LOADFILE_H_

#include <list>
#include <string>
#include <netinet/in.h>
#include <queue>

#include "connectbase.h"
#include "contraintes.h"
#include "mutex.h"
#include "thread.h"
#include "urlinfo.h"


class LoadFile : protected Thread  {
public:
	struct File {
		UrlInfo url;		
		string data;
	};
	
	LoadFile( Contraintes & );
	~LoadFile();

	bool isLoading( const string & );
	void loadFile( const UrlInfo & url );		
		
	void waitFile();
	File & getFile();
	void popFile();
	
	void stop();

private:	
	static ConnectBase dataBase;
	bool quit;	

	Mutex mutexFile;
	Mutex mutexUrl;
	Mutex mutexNbUrl;
	Mutex mutexNbFile;
	typedef priority_queue<UrlInfo> FifoUrl;
	typedef list<File> FifoFile;
	FifoUrl urlToLoad;
	FifoFile fifoLoadedFile;
	Contraintes & contraint;

protected:
	File & newCurrentFile();
	void pushUrl( const UrlInfo & );
	UrlInfo popUrl();

	virtual void run();
	
	bool getHostByName( const char * url, string & nameServer, string & path, sockaddr_in & addr );	
	bool getHttpFile( const char * url, string & page );	

	const char * strError();		
	
};

#endif
