/***************************************************************************
                          spider.cpp  -  description
                             -------------------
    begin                : Wed May 22 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include <unistd.h>

#include "traitedoc.h"

#include "spider.h"


void Spider::run() {
	while( !quit ) {
		loadFile.waitFile();
		if( quit )
			break;
		LoadFile::File & file = loadFile.getFile();
			
		if( file.data.empty()  ) {
			dataBase.ajoutMauvaisUrl( file.url.url );
		}
		else {
			clog << "PARSE" << file.url.priority << ' ' << file.url.url << endl;
			
			TraiteDoc parse( file.url.url, file.data, contraint );

			if( parse.wordInTheme() > 0 ) { // Si on a trouv des mots du theme
				for(vector<string>::const_iterator lien_c = parse.getLink().begin(); lien_c != parse.getLink().end(); ++lien_c) {
					string url = *lien_c;
					if( !dataBase.dejaVu( url ) ) { // On teste si on a dj visit cette page	
						// ajout du lien avec le nombre de mots du thme comme priorit
						UrlInfo info ( *lien_c, parse.wordInTheme() );
						loadFile.loadFile( info );
					}
				}
			}
			else if( file.url.getPriority() >= - contraint.getProfondeur() ) { //Si il n'y a pas de mots du thme mais la limite des sites traverss sans mots n'est pas atteinte
				for(vector<string>::const_iterator lien_c = parse.getLink().begin(); lien_c != parse.getLink().end(); ++lien_c) {	
					string url = *lien_c;
					if( !dataBase.dejaVu( url ) ) {// On teste si on a dj visit cette page	
						// ajout du lien avec comme priorit celle de son pre - 1
		  				UrlInfo info ( *lien_c, file.url.getPriority()-1 );
						loadFile.loadFile( info );
					}
				}
			}
			else // La limite des pages traverses est atteinte donc on place les liens comme urls invalides
				for(vector<string>::const_iterator lien_c = parse.getLink().begin(); lien_c != parse.getLink().end(); ++lien_c) {
					string url = *lien_c;
					dataBase.ajoutMauvaisUrl( url );
					clog << "LIMITE ATTEINTE: " << *lien_c << endl;
				}

/*			for(vector<string>::const_iterator i = parse.getLink().begin(); i != parse.getLink().end(); ++i) {
//				string url = *i;
//				if( !loadFile.isLoading( url ) && !dataBase.dejaVu( url ) )
					UrlInfo url ( *i, 1 );
					loadFile.loadFile( url );

			}*/
		}
				
		loadFile.popFile();
	}
}


Spider::Spider( Contraintes & c ) : quit( false ), loadFile( c ), contraint( c ) {
	start();
}


Spider::~Spider() {
	quit = true;
	loadFile.stop();
	join();
}


void Spider::loop() {
	string cmd;
	do {
		cin >> cmd;
		UrlInfo url ( cmd, 0 );
		loadFile.loadFile( url );
	} while( cmd != "exit" );
}
