/***************************************************************************
                          thread.cpp  -  description
                             -------------------
    begin                : Fri May 24 2002
    copyright            : (C) 2002 by Decis Christophe,ESSI1 ,11 Sep 00,365
    email                : decis@essi.fr
 ***************************************************************************/

#include "thread.h"


void * Thread::startRoutine( void * ptr ) {
	((Thread *) ptr)->run();
	pthread_exit( 0 );
}


Thread::Thread() : running( false ) {}


Thread::~Thread() {
	stop();
}


void Thread::start() {
	stop();
	running = true;
	pthread_create( &thread, 0, startRoutine, this );
}



void Thread::stop() {
	if( isRunning() )
		pthread_detach( thread );
	running = false;		
}


void Thread::join() {
	if( running ) {
		void * val;
		pthread_join( thread, &val );
	}
}


bool Thread::isRunning() const {
	return running;
}
