#include "parseps.h"

#include "traitedoc.h"

//**********************************************************************************************************************************************************************
//
//Constructeur


TraiteDoc::TraiteDoc(string & urlFic, string & texte,Contraintes & con):text(texte),nbMotTheme(0),urlFile(urlFic),redirection(false),contrainte(con){
  //cout<<"inTraiteDoc"<<endl;
  decomposeURL(urlFic);
  //cout<<"INInfotype"<<endl;
  infoType();
    //cout<<"INInfotype"<<endl;
  //suppression de l'entete du document
  text.erase( 0, text.find( "\r\n\r\n" ) + 4 );
  traiterPage();
  //cout<<"OutTraiteDoc"<<endl;
}


//**********************************************************************************************************************************************************************
//
//renvoie les liens du documents

vector<string> &TraiteDoc::getLink(){
  return lien;
}


//**********************************************************************************************************************************************************************
//
//renvoie le nombre de mot du thme trouv dans le document

unsigned int TraiteDoc::wordInTheme(){
  return nbMotTheme;
}


//**********************************************************************************************************************************************************************
//
//On extrait le repertoir ou chemin ou domaine de l'url ===la base ex http://www.essi.fr/bond/index.html ==> http://www.essi.fr/bond
//pas de '/' de fin!!

void TraiteDoc::decomposeURL(string & url){
  unsigned int taille=url.length();
  unsigned int pas=0;
  //suppression des espaces de debut
  while(pas<taille&& url[pas]==' ')
  	pas++;
  url=url.substr(pas,taille-pas+1);
  //recherche du premier '/' en commencant par la fin
  while(--taille>=0&&url[taille]!='/');
	//recherche du chemin, repertoire ou domaine de la page
  if(taille>0){
  	if(url[taille-1]=='/'&&(taille==1||(taille>=6&&lowerCase(url).substr(taille-6,7)=="http://"))){//on a une URL du type "http://www.essi.fr"   ===> "http://www.essi.fr"
  		while(++taille<url.length()&&url[taille]!=' ');
  		taille--;
  	}else{//on a une URL du type "http://www.essi.fr/toto/"  ===> "http://www.essi.fr/toto"
  		if(url[taille+1]==' '){
  			while(--taille>=0&&url[taille]=='/');
  		}else{//on alors soit un fichier soit un repertoire aprs le '/'
  			bool fichier=false;
  			unsigned int tailletmp=taille;
  			//on cherche s'il y a un point indiquant que c'est un fichier
  			while(++tailletmp<url.length()&&url[tailletmp]!=' '){
  				if(url[tailletmp]=='.')
  					fichier=true;
  			}
  			if(fichier){//on a une URL du type "http://www.essi.fr/index.html"    ===> "http://www.essi.fr"
  				while(--taille>=0&&url[taille]=='/');
  			}else{//on a une URL du type "http://www.essi.fr/toto"   ===> "http://www.essi.fr/toto"
  				taille=tailletmp-1;
  			}
  		}
	}
  }
  //extraction du chemin, reperetoire ou domaine
   cheminFic=url.substr(0,taille+1);
}

//**********************************************************************************************************************************************************************
//
//On regarde le header du fichier et le type du fichier et si on a une redirection
//

void TraiteDoc::infoType(){
  istrstream flux ( text.c_str(), text.length() );
  string mot="";
  flux >> mot;
  flux >> mot;
  if(mot=="200"||mot=="302"){//type correcte et traite
    if(mot=="302"){//une redirection (recherche de la ligne indiquant l'url de redirection
      	while( flux.good()&&lowerCase(mot)!="location:")
				flux >> mot;
			while( flux.good()&&lowerCase(mot)=="location:")
				flux >> mot;
			if(lowerCase(mot).substr(0,7)=="http://")
				 lien.push_back(mot);
			else
				if(mot[0]=='/')
   	   		lien.push_back(cheminFic+mot);
   	   	else
   	   		 lien.push_back(cheminFic+"/"+mot);
      	redirection=true;
   	}else{//page correcte, recherche du type du document
    		while( flux.good()&&lowerCase(mot)!= "content-type:")
      		flux >> mot;
    		flux >>mot;
    		int taille=mot.length();
    		if(mot[--taille]!=';')
    		taille++;
    		while(--taille>=0&&mot[taille]!='/');
    		extFic=mot.substr(taille+1,mot.length()-taille-1);
    		extFic=lowerCase(extFic);
    	}
  	}else{//type incorrecte
    	extFic="bad";
  }
}

//**********************************************************************************************************************************************************************
//
//Supprime les ../ et ./ d'une adresse tel que ../../toto/index.html et si l chemin est http://www.essi.fr/algo/moi ==>http://www.essi.fr/toto/index.html
//
string TraiteDoc::liftingLien(string url){
  //combien de ../ ou ./ il y a?
  int nbDecalage=0; 
  //passage 1 nb de decalage
  unsigned int inc=0;
  bool fini=false;
  //on avance tant que l'on reconnait ../ ou ./
  while(!fini){
  	if(url.substr(inc,3)=="../"){
    	nbDecalage++;
    	inc+=3;
  	}else{
  		if(url.substr(inc,2)=="./"){
   			 inc+=2;
   		}else{
     		fini=true;
 		}
  	}
  }
  //suppression des decalages
  int dec=cheminFic.length();
  while(--dec>=0&&cheminFic[dec]=='/');
  while(--nbDecalage>=0){
    while(--dec>=0&&cheminFic[dec]!='/');
    while(--dec>=0&&cheminFic[dec]=='/');
  }
  //on regarde on ne serait pas remonter trop haut dans l'adresse indiquant une erreur dans l'url
  if(dec<0||lowerCase(cheminFic)=="http:"||lowerCase(cheminFic)=="file:")
  	return "ERROR";
  return cheminFic.substr(0,dec)+'/'+url.substr(inc,url.length()-inc);
}

//**********************************************************************************************************************************************************************
//
//Corrections des liens trouv dans le document(mise en absolu, extraction si necessaire, reduction de l'url,...)
//
void TraiteDoc::correctionLiens(){
  int vectsize =lien.size();
  bool valide;
  int size=cheminFic.length();
  //suppression du / de fin de cheminFic
    while((--size)>0 &&(cheminFic[size]==' ' ||cheminFic[size]=='/'));
    cheminFic=cheminFic.substr(0,size+1);
//debut du traitement des liens
  vector<string>::iterator it=lien.begin();
  for(int i=0;i<vectsize;i++){
  	valide=true;
    string link=lien[i];
    //cout<<"0"<<link<<endl;
    int taille=link.size();
    //suppression des \n \r et \t
     int pas =0;
     string mot="";
    while(pas<taille){
      if (link[pas]=='\n'||link[pas]=='\t'||link[pas]=='\r'){
	  pas++;
      }else{
	mot=mot+link[pas++];
      }
    }
    link=mot;
    //On prend que le http:// ou file:// de fin
    //ex: http://www.esii.fr/toto/url?htpp://www.yahoo.fr  ==> http://www.yahoo.fr
   taille=link.size();
   int tailletmp=taille-7;
    //cout<<"a";//<<link<<endl;
   string lowerCaseLink=link;
   lowerCase(lowerCaseLink);
	while((tailletmp>=0)&&(lowerCaseLink.substr(tailletmp,7)!="http://" && lowerCaseLink.substr(tailletmp,6)!="file:/"))
		tailletmp--;

	if(tailletmp>=0){
		if(( lowerCaseLink.substr(tailletmp,7)=="http://" || lowerCaseLink.substr(tailletmp,6)=="file:/")){
			link=link.substr(tailletmp,taille-tailletmp);
			taille=link.size();
		}
	}
	 //cout<<"b";//<<link<<endl;
    //suppression des espaces de fin et '/' mais pas de "./"
    while((--taille)>0 &&(link[taille]==' ' ||link[taille]=='/')&&link.substr(taille-1,2)!="./");
    link=link.substr(0,taille+1);
		// cout<<"1";//<<link<<endl;
    //verification que ce n'est pas un lien interne a une page
    //ex  http://www.essi.fr/#top
    while(--taille>=0 && link[taille]!='/'){
    		if(link[taille]=='#'){
      		lien.erase(it);
      		vectsize--;
      		i--;
      		it--;
      		valide=false;
      		break;
      	}
     }
	//cout<<"c";//<<link<<endl;
 	  if(link[taille]!='#'){
 	      pas=0;
   	   taille=link.size();
     	//suppresion des espaces inutiles et '/' devant
     	while(pas<taille &&( link[pas]==' '||link[pas]=='/'))
			pas++;
		//taille trop importante pour une URL et permet de stopper si on passe dans un lien symbolique
		if((taille-pas)>200){
			lien.erase(it);
      		vectsize--;
      		i--;
      		it--;
      		valide=false;
      	}
      //			 cout<<"2"<<link<<endl;
      	 if((taille-pas)<=200){
      	// cout<<"d";//<<link<<endl;
				//chemin absolu accepter
				//ex    http://www.essi.fr
				string linkLowerCase=link;
				 lowerCase(lowerCaseLink);//evite de recalculer le lowercase  chaque fois de l'url
				if( linkLowerCase.substr(pas,7)=="http://" || linkLowerCase.substr(pas,6)=="file:/"){
	  				lien[i]=link.substr(pas,taille-pas);
				}else{
	  				//chemin absolu incomplet
	  				//cout<<"e";//<<link<<endl;
	  				if( linkLowerCase.substr(pas,3)=="www"){
	    				lien[i]="http://"+link.substr(pas,taille-pas);	
	  				}else{
	    				///ceux que l'on ne veux pas, on les elimine
	    				//cout<<"f";//<<link<<endl;
	    				if( linkLowerCase.substr(pas,8)=="https://"|| linkLowerCase.substr(pas,6)=="ftp://"||linkLowerCase.substr(pas,7)=="mailto:"|| linkLowerCase.substr(pas,11)=="javascript:"){
	      				lien.erase(it);
	      				vectsize--;
	      				i--;
	      				it--;
	      				valide=false;
	    				}else{
	      					//c'est un repertoire a  echelon ex:../ ou ./
	      					if(link[pas]=='.'){
	      							// cout<<"3";//<<link<<endl;
								string temp=liftingLien(link.substr(pas,taille-pas));
										// cout<<"4"<<link<<endl;
								if (temp=="ERROR"){
									lien.erase(it);
	      							vectsize--;
	      							i--;
	      							it--;
	      							valide=false;
	    						}else{
	    							lien[i]=temp;
	    						}
	      					}else{
								//il est correcte mais en relatif sans le '/'
								lien[i]=cheminFic+'/'+link.substr(pas,taille-pas);	
	      					}
	    				}
	  				}
				}
			}
		}
		
		//mise du / en fin de fichier
		if(valide){
			 //cout<<"5"<<lien[i]<<endl;
			link=lien[i];
			bool fichier =false;
			taille=link.length()-1;
			while(taille>=0&&link[taille]!='/'){
				if(link[taille]=='.')
					fichier=true;
				taille--;
			}
			if(!(taille>=0&&fichier&&link[taille-1]!='/'))
				lien[i]=link+'/';		
			// cout<<"6"<<lien[i]<<endl;
		}
    	it++;
  	}
}

//**********************************************************************************************************************************************************************
//
//traite la page pour extraire les mots et les liens selon le type du document

bool TraiteDoc::traiterPage(){
//cout<<"0";
  if (!contrainte.isInDomaine(urlFile))//on regarde suivant la contrainte impose par le domaine
    return false;
  //cout<<"0";
  if (redirection){//on a une redirection, on quitte tout de suite
		correctionLiens();
    	return true;
    }
  //cout<<"1";
 if((extFic=="html")&&contrainte.typeAcceptable(extFic)){//on regarde s'il y a une contrainte dans les extensions et le type du lien
 	//cout<<"2";
    ParseHTML parse(text);//extraction des mots et liens pour le fichier texte ou html
    lien = parse.getLiens();//recuperation des liens
    //cout<<"InIndex"<<endl;
	//cout<<"2";
    index.index( urlFile.c_str(), "html", parse.getMots(),nbMotTheme, contrainte );//envoie pour l'indexation
    //cout<<"OutIndex"<<endl;
    //if(parse.getBase()!="")
    //  cheminFic=parse.getBase();
  }
  else if( extFic == "pdf"&&contrainte.typeAcceptable(extFic) ) {
    ParsePS parse(text);//traitement du pdf
    index.index( urlFile.c_str(), "pdf", parse.getMots(), nbMotTheme, contrainte );
  }
  else if( extFic == "ps"&&contrainte.typeAcceptable(extFic) ) {
    ParsePS parse(text);//traitement du pas
    index.index( urlFile.c_str(), "ps", parse.getMots(), nbMotTheme, contrainte );
  }

  else{
    return false;
   }
   //corrections des liens rcuperer
   //cout<<"inCorrectionLien"<<endl;
  //cout<<"3";
    correctionLiens();
    //cout<<"4";
    //cout<<"OutcorrectionLien"<<endl;
  	 return true;
}


//**********************************************************************************************************************************************************************
//**********************************************************************************************************************************************************************
//
//																		PARTIE TEST


/*
void main(){
  string typer="htm";
  Contraintes cont =Contraintes();
   cont.addWordOfTheme("poire",1);
   cont.addWordOfTheme("pomme",2);
   cont.addWordOfTheme("peche",1);
   cont.addTypeOfExtension(typer);
  
   string s="http://www.code.bidon/toto1/toto2/lurlabsolu.htm";
   string t="toto bla bla tom pomme poire tre gdh jy fraise e loire";
   string m="http://www.voila.fr/#toto";
   string m0="./.././toto.html";
   string m1="mailto:ki.voici.fr";
   string m2="http://www.gn\nu.org";
   string m5="javascript://super.htm";
   string m4="    http://www.yahoo.fr    ";
   string m3="www";
   string m6="#dddxlo.htm";
   string file="HTTP/1.1 200 Bad Request
 Date: Wed, 29 May 2002 16:21:56 GMT
 Server: Apache/1.3.20 (Unix)
 Connection: close
 Transfer-Encoding: chunked
 Content-Type: text/html; charset=iso-8859-1 

145 
 <!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">
 <HTML><HEAD>
 <TITLE>400 Bad Request</TITLE>
 </HEAD><BODY>
 <H1>Bad Request</H1>
 Your browser sent a request that this server could not understand.<P>
 Invalid URI in request GET : HTTP/1.1<P>
 <HR>
 <ADDRESS>Apache/1.3.20 Server at www.voila.fr Port 80</ADDRESS>
 </BODY></HTML>";
  
   TraiteDoc v = TraiteDoc(s,file,cont);
   v.infoType();
   v.addLien(m);
   v.addLien(m0);
   v.addLien(m1);
   v.addLien(m2);
   v.addLien(m3);
   v.addLien(m4);
   v.addLien(m5); 
   v.addLien(m6);
   cout <<"avant"<<endl;
   v.showLien();
   cout <<endl;
   v.correctionLiens();
   cout <<endl<<"apres"<<endl;
   v.showLien(); 
} 

*/
//**********************************************************************FIN***********************************************************************************
